#include <pthread.h>
#include <stdio.h>
#include <unistd.h>
#include "psleep.h"

// Fonction exécutée par les threads
void *task1(void *arg) {
    printf("Thread_1 en cours...\n");
    sleep(2);
    printf("Thread_1 termine.\n");
    return NULL;
}
void *task2(void *arg) {
    printf("Thread_2 en cours...\n");
    sleep(2);
    printf("Thread_2 termine.\n");
    return NULL;
}

int main() {
    pthread_t thread1, thread2;
    pthread_attr_t attr;

    // 1_Initialisation des attributs
    pthread_attr_init(&attr);

    // 2️_Création d'un thread joignable (par défaut)
    pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_JOINABLE);
    pthread_create(&thread1, &attr, task1, NULL);

    // 3️_Création d'un thread détaché
    pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
    pthread_create(&thread2, &attr, task2, NULL);

    // 4️_Détruire les attributs après utilisation
    pthread_attr_destroy(&attr);

    // 5️_Attendre uniquement le thread joignable
    pthread_join(thread1, NULL);

    printf("Fin du programme principal.\n");

    return 0;
}
